Index: c/src/lib/libbsp/i386/pc386/clock/ckinit.c
===================================================================
--- c/src/lib/libbsp/i386/pc386/clock/ckinit.c	(revision 12579b2d90e70ab86d7226f32996dd5899456ba7)
+++ c/src/lib/libbsp/i386/pc386/clock/ckinit.c	(revision 888fadaf53b3ad8f575a5e61a475660ae8ba79aa)
@@ -258,6 +258,4 @@
 } /* Clock_exit */
 
-#define Clock_driver_support_shutdown_hardware() clockOff()
-
 bool Clock_isr_enabled = false;
 static void Clock_isr_handler(void *param)
Index: c/src/lib/libbsp/i386/pc386/console/inch.c
===================================================================
--- c/src/lib/libbsp/i386/pc386/console/inch.c	(revision 12579b2d90e70ab86d7226f32996dd5899456ba7)
+++ c/src/lib/libbsp/i386/pc386/console/inch.c	(revision 888fadaf53b3ad8f575a5e61a475660ae8ba79aa)
@@ -240,10 +240,8 @@
 } /* _IBMPC_inch */
 
- /*
-  * Routine that can be used before interrupt management is initialized.
-  */
-
-int
-BSP_wait_polled_input(void)
+/*
+ * Routine that can be used before interrupt management is initialized.
+ */
+int BSP_wait_polled_input(void)
 {
   char c;
Index: c/src/lib/libbsp/i386/pc386/include/bsp.h
===================================================================
--- c/src/lib/libbsp/i386/pc386/include/bsp.h	(revision 12579b2d90e70ab86d7226f32996dd5899456ba7)
+++ c/src/lib/libbsp/i386/pc386/include/bsp.h	(revision 888fadaf53b3ad8f575a5e61a475660ae8ba79aa)
@@ -178,4 +178,8 @@
 char          _IBMPC_inch     (void);    /* from 'inch.c'   */
 char          _IBMPC_inch_sleep (void);  /* from 'inch.c'   */
+int           BSP_wait_polled_input(void); /* from 'inch.c' */
+int           rtems_kbpoll( void );      /* from 'inch.c' */
+int           getch( void );             /* from 'inch.c' */
+void           add_to_queue( unsigned short b ); /* from 'inch.c' */
 
 void Wait_X_ms(unsigned int timeToWait); /* from 'timer.c'  */
@@ -189,4 +193,5 @@
 void Clock_driver_support_initialize_hardware(void); /* from 'ckinit.c'  */
 
+void kbd_reset_setup(char *str, int *ints);   /* from 'pc_keyb.c' */
 size_t read_aux(char * buffer, size_t count); /* from 'ps2_mouse.c'  */
 
Index: c/src/lib/libbsp/i386/shared/comm/i386-stub.c
===================================================================
--- c/src/lib/libbsp/i386/shared/comm/i386-stub.c	(revision 12579b2d90e70ab86d7226f32996dd5899456ba7)
+++ c/src/lib/libbsp/i386/shared/comm/i386-stub.c	(revision 888fadaf53b3ad8f575a5e61a475660ae8ba79aa)
@@ -466,5 +466,5 @@
 
 /* scan for the sequence $<data>#<checksum>     */
-void
+static void
 getpacket (char *buffer)
 {
@@ -530,5 +530,5 @@
 /* send the packet in buffer.  */
 
-void
+static void
 putpacket (char *buffer)
 {
@@ -632,5 +632,5 @@
 /* convert the hex array pointed to by buf into binary to be placed in mem */
 /* return a pointer to the character AFTER the last byte written */
-char *
+static char *
 hex2mem (char *buf, char *mem, int count, int may_fault)
 {
Index: c/src/lib/libbsp/i386/shared/comm/uart.c
===================================================================
--- c/src/lib/libbsp/i386/shared/comm/uart.c	(revision 12579b2d90e70ab86d7226f32996dd5899456ba7)
+++ c/src/lib/libbsp/i386/shared/comm/uart.c	(revision 888fadaf53b3ad8f575a5e61a475660ae8ba79aa)
@@ -61,13 +61,15 @@
 }
 
+static void
+uartError(int uart)
+{
+  unsigned char uartStatus, dummy;
+
+  uartStatus = uread(uart, LSR);
+  (void) uartStatus; /* avoid set but not used warning */
+  dummy = uread(uart, RBR);
+  (void) dummy;      /* avoid set but not used warning */
+
 #ifdef UARTDEBUG
-    static void
-uartError(int uart)
-{
-  unsigned char uartStatus, dummy;
-
-  uartStatus = uread(uart, LSR);
-  dummy = uread(uart, RBR);
-
   if (uartStatus & OE)
     printk("********* Over run Error **********\n");
@@ -80,13 +82,6 @@
   if (uartStatus & ERFIFO)
     printk("********* Error receive Fifo **********\n");
-
-}
-#else
-inline void uartError(int uart)
-{
-  uread(uart, LSR);
-  uread(uart, RBR);
-}
 #endif
+}
 
 /*
@@ -456,5 +451,8 @@
  * from the serial port.
  */
-void uart_set_driver_handler( int port, void ( *handler )( void *,  char *, int ) )
+static void uart_set_driver_handler(
+  int port,
+  void ( *handler )( void *,  char *, int )
+)
 {
   switch( port )
Index: c/src/lib/libbsp/i386/shared/irq/irq_init.c
===================================================================
--- c/src/lib/libbsp/i386/shared/irq/irq_init.c	(revision 12579b2d90e70ab86d7226f32996dd5899456ba7)
+++ c/src/lib/libbsp/i386/shared/irq/irq_init.c	(revision 888fadaf53b3ad8f575a5e61a475660ae8ba79aa)
@@ -99,4 +99,8 @@
 static rtems_raw_irq_global_settings raw_initial_config;
 
+
+/*
+ *  This method is called from irq_asm.S and cannot be static.
+ */
 void raw_idt_notify(void)
 {