Index: c/src/lib/libbsp/hppa1.1/simhppa/ChangeLog
===================================================================
--- c/src/lib/libbsp/hppa1.1/simhppa/ChangeLog	(revision 9daf475f46cd3536b5274f20112b9dce5baf1c04)
+++ c/src/lib/libbsp/hppa1.1/simhppa/ChangeLog	(revision 893af3e8da848884c5c49e22d5d3ea44939a8639)
@@ -1,2 +1,9 @@
+2003-09-04	Joel Sherrill <joel@OARcorp.com>
+
+	* include/bsp.h, shmsupp/addrconv.c, shmsupp/cause_intr.c,
+	shmsupp/getcfg.c, shmsupp/lock.c, shmsupp/mpisr.c,
+	startup/bspclean.c, startup/bspstart.c, startup/setvec.c,
+	tools/print_dump.c, tty/tty.c: URL for license changed.
+
 2003-08-22	Joel Sherrill <joel@OARcorp.com>
 
Index: c/src/lib/libbsp/hppa1.1/simhppa/include/bsp.h
===================================================================
--- c/src/lib/libbsp/hppa1.1/simhppa/include/bsp.h	(revision 9daf475f46cd3536b5274f20112b9dce5baf1c04)
+++ c/src/lib/libbsp/hppa1.1/simhppa/include/bsp.h	(revision 893af3e8da848884c5c49e22d5d3ea44939a8639)
@@ -8,5 +8,5 @@
  *  The license and distribution terms for this file may be
  *  found in the file LICENSE in this distribution or at
- *  http://www.OARcorp.com/rtems/license.html.
+ *  http://www.rtems.com/license/LICENSE.
  *
  *  $Id$
Index: c/src/lib/libbsp/hppa1.1/simhppa/shmsupp/addrconv.c
===================================================================
--- c/src/lib/libbsp/hppa1.1/simhppa/shmsupp/addrconv.c	(revision 9daf475f46cd3536b5274f20112b9dce5baf1c04)
+++ c/src/lib/libbsp/hppa1.1/simhppa/shmsupp/addrconv.c	(revision 893af3e8da848884c5c49e22d5d3ea44939a8639)
@@ -14,5 +14,5 @@
  *  The license and distribution terms for this file may be
  *  found in the file LICENSE in this distribution or at
- *  http://www.OARcorp.com/rtems/license.html.
+ *  http://www.rtems.com/license/LICENSE.
  *
  *  $Id$
Index: c/src/lib/libbsp/hppa1.1/simhppa/shmsupp/cause_intr.c
===================================================================
--- c/src/lib/libbsp/hppa1.1/simhppa/shmsupp/cause_intr.c	(revision 9daf475f46cd3536b5274f20112b9dce5baf1c04)
+++ c/src/lib/libbsp/hppa1.1/simhppa/shmsupp/cause_intr.c	(revision 893af3e8da848884c5c49e22d5d3ea44939a8639)
@@ -14,5 +14,5 @@
  *  The license and distribution terms for this file may be
  *  found in the file LICENSE in this distribution or at
- *  http://www.OARcorp.com/rtems/license.html.
+ *  http://www.rtems.com/license/LICENSE.
  *
  *  $Id$
Index: c/src/lib/libbsp/hppa1.1/simhppa/shmsupp/getcfg.c
===================================================================
--- c/src/lib/libbsp/hppa1.1/simhppa/shmsupp/getcfg.c	(revision 9daf475f46cd3536b5274f20112b9dce5baf1c04)
+++ c/src/lib/libbsp/hppa1.1/simhppa/shmsupp/getcfg.c	(revision 893af3e8da848884c5c49e22d5d3ea44939a8639)
@@ -29,5 +29,5 @@
  *  The license and distribution terms for this file may be
  *  found in the file LICENSE in this distribution or at
- *  http://www.OARcorp.com/rtems/license.html.
+ *  http://www.rtems.com/license/LICENSE.
  *
  *  $Id$
Index: c/src/lib/libbsp/hppa1.1/simhppa/shmsupp/lock.c
===================================================================
--- c/src/lib/libbsp/hppa1.1/simhppa/shmsupp/lock.c	(revision 9daf475f46cd3536b5274f20112b9dce5baf1c04)
+++ c/src/lib/libbsp/hppa1.1/simhppa/shmsupp/lock.c	(revision 893af3e8da848884c5c49e22d5d3ea44939a8639)
@@ -12,5 +12,5 @@
  *  The license and distribution terms for this file may be
  *  found in the file LICENSE in this distribution or at
- *  http://www.OARcorp.com/rtems/license.html.
+ *  http://www.rtems.com/license/LICENSE.
  *
  *  $Id$
Index: c/src/lib/libbsp/hppa1.1/simhppa/shmsupp/mpisr.c
===================================================================
--- c/src/lib/libbsp/hppa1.1/simhppa/shmsupp/mpisr.c	(revision 9daf475f46cd3536b5274f20112b9dce5baf1c04)
+++ c/src/lib/libbsp/hppa1.1/simhppa/shmsupp/mpisr.c	(revision 893af3e8da848884c5c49e22d5d3ea44939a8639)
@@ -13,5 +13,5 @@
  *  The license and distribution terms for this file may be
  *  found in the file LICENSE in this distribution or at
- *  http://www.OARcorp.com/rtems/license.html.
+ *  http://www.rtems.com/license/LICENSE.
  *
  *  $Id$
Index: c/src/lib/libbsp/hppa1.1/simhppa/startup/bspclean.c
===================================================================
--- c/src/lib/libbsp/hppa1.1/simhppa/startup/bspclean.c	(revision 9daf475f46cd3536b5274f20112b9dce5baf1c04)
+++ c/src/lib/libbsp/hppa1.1/simhppa/startup/bspclean.c	(revision 893af3e8da848884c5c49e22d5d3ea44939a8639)
@@ -14,5 +14,5 @@
  *  The license and distribution terms for this file may be
  *  found in the file LICENSE in this distribution or at
- *  http://www.OARcorp.com/rtems/license.html.
+ *  http://www.rtems.com/license/LICENSE.
  *
  *  $Id$
Index: c/src/lib/libbsp/hppa1.1/simhppa/startup/bspstart.c
===================================================================
--- c/src/lib/libbsp/hppa1.1/simhppa/startup/bspstart.c	(revision 9daf475f46cd3536b5274f20112b9dce5baf1c04)
+++ c/src/lib/libbsp/hppa1.1/simhppa/startup/bspstart.c	(revision 893af3e8da848884c5c49e22d5d3ea44939a8639)
@@ -10,5 +10,5 @@
  *  The license and distribution terms for this file may be
  *  found in the file LICENSE in this distribution or at
- *  http://www.OARcorp.com/rtems/license.html.
+ *  http://www.rtems.com/license/LICENSE.
  *
  *  $Id$
Index: c/src/lib/libbsp/hppa1.1/simhppa/startup/setvec.c
===================================================================
--- c/src/lib/libbsp/hppa1.1/simhppa/startup/setvec.c	(revision 9daf475f46cd3536b5274f20112b9dce5baf1c04)
+++ c/src/lib/libbsp/hppa1.1/simhppa/startup/setvec.c	(revision 893af3e8da848884c5c49e22d5d3ea44939a8639)
@@ -19,5 +19,5 @@
  *  The license and distribution terms for this file may be
  *  found in the file LICENSE in this distribution or at
- *  http://www.OARcorp.com/rtems/license.html.
+ *  http://www.rtems.com/license/LICENSE.
  *
  *  $Id$
Index: c/src/lib/libbsp/hppa1.1/simhppa/tools/print_dump.c
===================================================================
--- c/src/lib/libbsp/hppa1.1/simhppa/tools/print_dump.c	(revision 9daf475f46cd3536b5274f20112b9dce5baf1c04)
+++ c/src/lib/libbsp/hppa1.1/simhppa/tools/print_dump.c	(revision 893af3e8da848884c5c49e22d5d3ea44939a8639)
@@ -6,5 +6,5 @@
  *  The license and distribution terms for this file may be
  *  found in the file LICENSE in this distribution or at
- *  http://www.OARcorp.com/rtems/license.html.
+ *  http://www.rtems.com/license/LICENSE.
  *
  *  $Id$
Index: c/src/lib/libbsp/hppa1.1/simhppa/tty/tty.c
===================================================================
--- c/src/lib/libbsp/hppa1.1/simhppa/tty/tty.c	(revision 9daf475f46cd3536b5274f20112b9dce5baf1c04)
+++ c/src/lib/libbsp/hppa1.1/simhppa/tty/tty.c	(revision 893af3e8da848884c5c49e22d5d3ea44939a8639)
@@ -10,5 +10,5 @@
  *  The license and distribution terms for this file may be
  *  found in the file LICENSE in this distribution or at
- *  http://www.OARcorp.com/rtems/license.html.
+ *  http://www.rtems.com/license/LICENSE.
  *
  *  $Id$