Index: c/src/lib/libbsp/h8300/h8sim/ChangeLog
===================================================================
--- c/src/lib/libbsp/h8300/h8sim/ChangeLog	(revision eb65a1a0902c4754adbbafbff3883bb10039b5d4)
+++ c/src/lib/libbsp/h8300/h8sim/ChangeLog	(revision 901e5b15ccce05e10eb8d1d6cc5e5816a84f3807)
@@ -1,2 +1,9 @@
+2003-12-10	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
+
+	* clock/Makefile.am: Misc cleanups and fixes.
+	* start/Makefile.am: Misc cleanups and fixes.
+	* startup/Makefile.am: Misc cleanups and fixes.
+	* wrapup/Makefile.am: Misc cleanups and fixes.
+
 2003-12-02	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
 
Index: c/src/lib/libbsp/h8300/h8sim/clock/Makefile.am
===================================================================
--- c/src/lib/libbsp/h8300/h8sim/clock/Makefile.am	(revision eb65a1a0902c4754adbbafbff3883bb10039b5d4)
+++ c/src/lib/libbsp/h8300/h8sim/clock/Makefile.am	(revision 901e5b15ccce05e10eb8d1d6cc5e5816a84f3807)
@@ -21,5 +21,5 @@
 .PRECIOUS:
 
-EXTRA_DIST = 
+EXTRA_DIST = $(C_FILES)
 
 include $(top_srcdir)/../../../../automake/local.am
Index: c/src/lib/libbsp/h8300/h8sim/start/Makefile.am
===================================================================
--- c/src/lib/libbsp/h8300/h8sim/start/Makefile.am	(revision eb65a1a0902c4754adbbafbff3883bb10039b5d4)
+++ c/src/lib/libbsp/h8300/h8sim/start/Makefile.am	(revision 901e5b15ccce05e10eb8d1d6cc5e5816a84f3807)
@@ -10,4 +10,5 @@
 include $(top_srcdir)/../../../../automake/compile.am
 include $(top_srcdir)/../../../../automake/lib.am
+include $(top_srcdir)/../../bspstart.am
 
 #
@@ -15,18 +16,13 @@
 #
 
-install-data-local: $(PROJECT_RELEASE)/lib/start$(LIB_VARIANT).$(OBJEXT)
-	@$(mkinstalldirs) $(DESTDIR)$(bsplibdir)
-	$(INSTALL_DATA) $< $(DESTDIR)$(bsplibdir)
+project_lib_DATA = $(ARCH)/start$(LIB_VARIANT).$(OBJEXT)
 
-$(PROJECT_RELEASE)/lib/start$(LIB_VARIANT).$(OBJEXT): $(ARCH)/start.$(OBJEXT)
-	$(INSTALL_DATA) $< $@
-
-TMPINSTALL_FILES += $(PROJECT_RELEASE)/lib/start$(LIB_VARIANT).$(OBJEXT)
-
-all-local: $(OBJS) $(ARCH)/start.$(OBJEXT) $(TMPINSTALL_FILES)
-
-.PRECIOUS: $(ARCH)/start.$(OBJEXT)
+all-local: $(TMPINSTALL_FILES)
 
 EXTRA_DIST = start.S
 
+${PROJECT_RELEASE}/lib/start$(LIB_VARIANT).$(OBJEXT): $(ARCH)/start$(LIB_VARIANT).$(OBJEXT) ${PROJECT_RELEASE}/lib/$(dirstamp)
+	$(INSTALL_DATA) $< ${PROJECT_RELEASE}/lib/start$(LIB_VARIANT).$(OBJEXT)
+TMPINSTALL_FILES += ${PROJECT_RELEASE}/lib/start$(LIB_VARIANT).$(OBJEXT)
+
 include $(top_srcdir)/../../../../automake/local.am
Index: c/src/lib/libbsp/h8300/h8sim/startup/Makefile.am
===================================================================
--- c/src/lib/libbsp/h8300/h8sim/startup/Makefile.am	(revision eb65a1a0902c4754adbbafbff3883bb10039b5d4)
+++ c/src/lib/libbsp/h8300/h8sim/startup/Makefile.am	(revision 901e5b15ccce05e10eb8d1d6cc5e5816a84f3807)
@@ -23,17 +23,15 @@
 	$(make-rel)
 
-bsplib_DATA = linkcmds
-
-$(PROJECT_RELEASE)/lib/linkcmds: linkcmds
-	$(INSTALL_DATA) $< $@
+project_lib_DATA = linkcmds
 
 # the .rel file built here will be put into libbsp.a by ../wrapup/Makefile
-TMPINSTALL_FILES += $(PROJECT_RELEASE)/lib/linkcmds
 
-all-local: $(OBJS) $(PGM) $(TMPINSTALL_FILES)
-
-.PRECIOUS: $(PGM)
+all-local: $(PGM) $(TMPINSTALL_FILES)
 
 EXTRA_DIST = bspclean.c bspstart.c exit.c linkcmds setvec.c
 
+${PROJECT_RELEASE}/lib/linkcmds: linkcmds ${PROJECT_RELEASE}/lib/$(dirstamp)
+	$(INSTALL_DATA) $< ${PROJECT_RELEASE}/lib/linkcmds
+TMPINSTALL_FILES += ${PROJECT_RELEASE}/lib/linkcmds
+
 include $(top_srcdir)/../../../../automake/local.am
Index: c/src/lib/libbsp/h8300/h8sim/wrapup/Makefile.am
===================================================================
--- c/src/lib/libbsp/h8300/h8sim/wrapup/Makefile.am	(revision eb65a1a0902c4754adbbafbff3883bb10039b5d4)
+++ c/src/lib/libbsp/h8300/h8sim/wrapup/Makefile.am	(revision 901e5b15ccce05e10eb8d1d6cc5e5816a84f3807)
@@ -9,6 +9,6 @@
 
 # bummer; have to use $foreach since % pattern subst rules only replace 1x
-OBJS = $(foreach piece, $(BSP_FILES), $(wildcard \
-    ../$(piece)/$(ARCH)/*.$(OBJEXT))) $(foreach piece, $(GENERIC_FILES), \
+OBJS = $(foreach piece, $(BSP_FILES), ../$(piece)/$(ARCH)/*.$(OBJEXT)) \
+    $(foreach piece, $(GENERIC_FILES), \
     ../../../$(piece)/$(ARCH)/$(piece).rel)
 