Index: ems/config/4.10/rtems-all.bset
===================================================================
--- rtems/config/4.10/rtems-all.bset	(revision cac72a2aea711f671816d7c41bb1cfe66d54ee37)
+++ 	(revision )
@@ -1,18 +1,0 @@
-#
-# All RTEMS 4.10 Tools Sets
-#
-
-4.10/rtems-autotools
-4.10/rtems-arm
-4.10/rtems-avr
-4.10/rtems-bfin
-4.10/rtems-i386
-4.10/rtems-lm32
-4.10/rtems-m32c
-4.10/rtems-m32r
-4.10/rtems-m68k
-4.10/rtems-mips
-4.10/rtems-nios2
-4.10/rtems-powerpc
-4.10/rtems-sh
-4.10/rtems-sparc
Index: ems/config/4.10/rtems-arm.bset
===================================================================
--- rtems/config/4.10/rtems-arm.bset	(revision cac72a2aea711f671816d7c41bb1cfe66d54ee37)
+++ 	(revision )
@@ -1,38 +1,0 @@
-#
-# Tools Set for RTEMS ARM 4.10 Stable
-#
-
-%define release 1
-
-%define rtems_arch arm
-
-#
-# The RTEMS 4.10 base defines.
-#
-%include rtems-4.10-base.bset
-
-#
-# The RTEMS 4.10 BSP to build and test
-#
-# Do not build: lm3s3749
-# For automated testing, edb7312 should be configured with:
-#    - ON_SKYEYE=1
-# The GDB based simulators could be used as defaults for testing though.
-# Skyeye includes coverage.
-#
-%define rtems_bsps      all
-%define rtems_test_bsps none
-
-#
-# Disable the tests because the samples do not build.
-#
-%define rtems_tests disable
-
-#
-# Tools configuration.
-#
-devel/expat-2.1.0-1
-tools/rtems-binutils-2.20.1-1
-tools/rtems-gcc-4.4.7-newlib-1.18.0-1
-tools/rtems-gdb-7.3.1-1
-tools/rtems-kernel-4.10.2
Index: ems/config/4.10/rtems-autotools.bset
===================================================================
--- rtems/config/4.10/rtems-autotools.bset	(revision cac72a2aea711f671816d7c41bb1cfe66d54ee37)
+++ 	(revision )
@@ -1,23 +1,0 @@
-#
-# Tools Set for RTEMS 4.9 Autotools Stable
-#
-
-%define release 1
-
-%define rtems_arch none
-
-#
-# The RTEMS 4.9 base defines.
-#
-%include rtems-4.9-base.bset
-
-#
-# The autotoolspackage.
-#
-package: rtems-%{rtems_version}-autotools-%{_host}-%{release}
-
-#
-# Tools configuration.
-#
-devel/autoconf-2.69-1
-devel/automake-1.12.2-1
Index: ems/config/4.10/rtems-avr.bset
===================================================================
--- rtems/config/4.10/rtems-avr.bset	(revision cac72a2aea711f671816d7c41bb1cfe66d54ee37)
+++ 	(revision )
@@ -1,28 +1,0 @@
-#
-# Tools Set for RTEMS AVR 4.10 Stable
-#
-
-%define release 1
-
-%define rtems_arch avr
-
-#
-# The RTEMS 4.10 base defines.
-#
-%include rtems-4.10-base.bset
-
-#
-# Disable building a C++ compiler.
-#  configure: error: unable to detect exception model
-#
-%define enable_cxx 0
-%define rtems_cxx  0
-
-#
-# Tools configuration.
-#
-devel/expat-2.1.0-1
-tools/rtems-binutils-2.20.1-1
-tools/rtems-gcc-4.4.7-newlib-1.18.0-1
-tools/rtems-gdb-7.3.1-1
-tools/rtems-kernel-4.10.2
Index: ems/config/4.10/rtems-bfin.bset
===================================================================
--- rtems/config/4.10/rtems-bfin.bset	(revision cac72a2aea711f671816d7c41bb1cfe66d54ee37)
+++ 	(revision )
@@ -1,32 +1,0 @@
-#
-# Tools Set for RTEMS BFIN 4.10 Stable
-#
-
-%define release 1
-
-%define rtems_arch bfin
-
-#
-# The RTEMS 4.10 base defines.
-#
-%include rtems-4.10-base.bset
-
-#
-# The RTEMS 4.11 BSP to build and test
-#
-%define rtems_bsps      all
-%define rtems_test_bsps none
-
-#
-# GDB simulator fix for the sed command.
-#
-%patch add gdb %{rtems_gdb_patches}/bfin/gdb-7.3.1-bfin-sim-fix-sed-20130319.diff
-
-#
-# Tools configuration.
-#
-devel/expat-2.1.0-1
-tools/rtems-binutils-2.20.1-1
-tools/rtems-gcc-4.4.7-newlib-1.18.0-1
-tools/rtems-gdb-7.3.1-1
-tools/rtems-kernel-4.10.2
Index: ems/config/4.10/rtems-h8300.bset
===================================================================
--- rtems/config/4.10/rtems-h8300.bset	(revision cac72a2aea711f671816d7c41bb1cfe66d54ee37)
+++ 	(revision )
@@ -1,27 +1,0 @@
-#
-# Tools Set for RTEMS H8300 4.10 Stable
-#
-
-%define release 1
-
-%define rtems_arch h8300
-
-#
-# The RTEMS 4.10 base defines.
-#
-%include rtems-4.10-base.bset
-
-#
-# The RTEMS 4.11 BSP to build and test
-#
-%define rtems_bsps      all
-%define rtems_test_bsps none
-
-#
-# Tools configuration.
-#
-devel/expat-2.1.0-1
-tools/rtems-binutils-2.20.1-1
-tools/rtems-gcc-4.4.7-newlib-1.18.0-1
-tools/rtems-gdb-7.3.1-1
-tools/rtems-kernel-4.10.2
Index: ems/config/4.10/rtems-i386.bset
===================================================================
--- rtems/config/4.10/rtems-i386.bset	(revision cac72a2aea711f671816d7c41bb1cfe66d54ee37)
+++ 	(revision )
@@ -1,31 +1,0 @@
-#
-# Tools Set for RTEMS i386 4.10 Stable
-#
-
-%define release 1
-
-%define rtems_arch i386
-
-#
-# The RTEMS 4.10 base defines.
-#
-%include rtems-4.10-base.bset
-
-#
-# The RTEMS 4.11 BSP to build and test
-#
-# For automated testing on Qemu, pc386 should be configured with:
-#    - USE_COM1_AS_CONSOLE=1
-#    - BSP_PRESS_KEY_FOR_RESET=0
-#    - BSP_RESET_BOARD_AT_EXIT=1
-%define rtems_bsps      all
-%define rtems_test_bsps none
-
-#
-# Tools configuration.
-#
-devel/expat-2.1.0-1
-tools/rtems-binutils-2.20.1-1
-tools/rtems-gcc-4.4.7-newlib-1.18.0-1
-tools/rtems-gdb-7.3.1-1
-tools/rtems-kernel-4.10.2
Index: ems/config/4.10/rtems-lm32.bset
===================================================================
--- rtems/config/4.10/rtems-lm32.bset	(revision cac72a2aea711f671816d7c41bb1cfe66d54ee37)
+++ 	(revision )
@@ -1,27 +1,0 @@
-#
-# Tools Set for RTEMS LM32 4.10 Stable
-#
-
-%define release 1
-
-%define rtems_arch lm32
-
-#
-# The RTEMS 4.10 base defines.
-#
-%include rtems-4.10-base.bset
-
-#
-# The RTEMS 4.11 BSP to build and test
-#
-%define rtems_bsps      all
-%define rtems_test_bsps lm32_evr
-
-#
-# Tools configuration.
-#
-devel/expat-2.1.0-1
-tools/rtems-binutils-2.20.1-1
-tools/rtems-gcc-4.4.7-newlib-1.18.0-1
-tools/rtems-gdb-7.3.1-1
-tools/rtems-kernel-4.10.2
Index: ems/config/4.10/rtems-m32c.bset
===================================================================
--- rtems/config/4.10/rtems-m32c.bset	(revision cac72a2aea711f671816d7c41bb1cfe66d54ee37)
+++ 	(revision )
@@ -1,27 +1,0 @@
-#
-# Tools Set for RTEMS M32C 4.10 Stable
-#
-
-%define release 1
-
-%define rtems_arch m32c
-
-#
-# The RTEMS 4.10 base defines.
-#
-%include rtems-4.10-base.bset
-
-#
-# Disable building a C++ compiler.
-#
-%define enable_cxx 0
-%define rtems_cxx  0
-
-#
-# Tools configuration.
-#
-devel/expat-2.1.0-1
-tools/rtems-binutils-2.20.1-1
-tools/rtems-gcc-4.4.7-newlib-1.18.0-1
-tools/rtems-gdb-7.3.1-1
-tools/rtems-kernel-4.10.2
Index: ems/config/4.10/rtems-m32r.bset
===================================================================
--- rtems/config/4.10/rtems-m32r.bset	(revision cac72a2aea711f671816d7c41bb1cfe66d54ee37)
+++ 	(revision )
@@ -1,21 +1,0 @@
-#
-# Tools Set for RTEMS M32R 4.10 Stable
-#
-
-%define release 1
-
-%define rtems_arch m32r
-
-#
-# The RTEMS 4.10 base defines.
-#
-%include rtems-4.10-base.bset
-
-#
-# Tools configuration.
-#
-devel/expat-2.1.0-1
-tools/rtems-binutils-2.20.1-1
-tools/rtems-gcc-4.4.7-newlib-1.18.0-1
-tools/rtems-gdb-7.3.1-1
-tools/rtems-kernel-4.10.2
Index: ems/config/4.10/rtems-m68k.bset
===================================================================
--- rtems/config/4.10/rtems-m68k.bset	(revision cac72a2aea711f671816d7c41bb1cfe66d54ee37)
+++ 	(revision )
@@ -1,23 +1,0 @@
-#
-# Tools Set for RTEMS m68k 4.10 Stable
-#
-
-%define release 1
-
-%define rtems_arch m68k
-
-#
-# The RTEMS 4.10 base defines.
-#
-%include rtems-4.10-base.bset
-%define rtems_bsps      all
-%define rtems_test_bsps none
-
-#
-# Tools configuration.
-#
-devel/expat-2.1.0-1
-tools/rtems-binutils-2.20.1-1
-tools/rtems-gcc-4.4.7-newlib-1.18.0-1
-tools/rtems-gdb-7.3.1-1
-tools/rtems-kernel-4.10.2
Index: ems/config/4.10/rtems-mips.bset
===================================================================
--- rtems/config/4.10/rtems-mips.bset	(revision cac72a2aea711f671816d7c41bb1cfe66d54ee37)
+++ 	(revision )
@@ -1,24 +1,0 @@
-#
-# Tools Set for RTEMS MIPS 4.10 Stable
-#
-
-%define release 1
-
-%define rtems_arch mips
-
-#
-# The RTEMS 4.10 base defines.
-#
-%include rtems-4.10-base.bset
-
-%define rtems_bsps      all
-%define rtems_test_bsps jmr3904
-
-#
-# Tools configuration.
-#
-devel/expat-2.1.0-1
-tools/rtems-binutils-2.20.1-1
-tools/rtems-gcc-4.4.7-newlib-1.18.0-1
-tools/rtems-gdb-7.3.1-1
-tools/rtems-kernel-4.10.2
Index: ems/config/4.10/rtems-nios2.bset
===================================================================
--- rtems/config/4.10/rtems-nios2.bset	(revision cac72a2aea711f671816d7c41bb1cfe66d54ee37)
+++ 	(revision )
@@ -1,26 +1,0 @@
-#
-# Tools Set for RTEMS NIOS 4.10 Stable
-#
-# The NIOS source is a special version released by Altera.
-#
-
-%define release 1
-
-%define rtems_arch nios2
-
-#
-# The RTEMS 4.10 base defines.
-#
-%include rtems-4.10-base.bset
-
-
-%define rtems_bsps      all
-%define rtems_test_bsps none
-
-#
-# Tools configuration.
-#
-devel/expat-2.1.0-1
-tools/rtems-nios2-binutils-2.20-1
-tools/rtems-nios2-gcc-4.1-newlib-1.19.0-1
-tools/rtems-nios2-gdb-7.0-1
Index: ems/config/4.10/rtems-powerpc.bset
===================================================================
--- rtems/config/4.10/rtems-powerpc.bset	(revision cac72a2aea711f671816d7c41bb1cfe66d54ee37)
+++ 	(revision )
@@ -1,22 +1,0 @@
-#
-# Tools Set for RTEMS PowerPC 4.10 Stable
-#
-
-%define release 1
-
-%define rtems_arch powerpc
-
-#
-# The RTEMS 4.10 base defines.
-#
-%include rtems-4.10-base.bset
-%define rtems_bsps      all
-%define rtems_test_bsps psim
-#
-# Tools configuration.
-#
-devel/expat-2.1.0-1
-tools/rtems-binutils-2.20.1-1
-tools/rtems-gcc-4.4.7-newlib-1.18.0-1
-tools/rtems-gdb-7.3.1-1
-tools/rtems-kernel-4.10.2
Index: ems/config/4.10/rtems-sh.bset
===================================================================
--- rtems/config/4.10/rtems-sh.bset	(revision cac72a2aea711f671816d7c41bb1cfe66d54ee37)
+++ 	(revision )
@@ -1,22 +1,0 @@
-#
-# Tools Set for RTEMS SH 4.10 Stable
-#
-
-%define release 1
-
-%define rtems_arch sh
-
-#
-# The RTEMS 4.10 base defines.
-#
-%include rtems-4.10-base.bset
-%define rtems_bsps      all
-%define rtems_test_bsps simsh1
-
-# Tools configurationt
-#
-devel/expat-2.1.0-1
-tools/rtems-binutils-2.20.1-1
-tools/rtems-gcc-4.4.7-newlib-1.18.0-1
-tools/rtems-gdb-7.3.1-1
-tools/rtems-kernel-4.10.2
Index: ems/config/4.10/rtems-sparc.bset
===================================================================
--- rtems/config/4.10/rtems-sparc.bset	(revision cac72a2aea711f671816d7c41bb1cfe66d54ee37)
+++ 	(revision )
@@ -1,22 +1,0 @@
-#
-# Tools Set for RTEMS SPARC 4.10 Stable
-#
-
-%define release 1
-
-%define rtems_arch sparc
-
-#
-# The RTEMS 4.10 base defines.
-#
-%include rtems-4.10-base.bset
-%define rtems_bsps      all
-%define rtems_test_bsps sis
-#
-# Tools configuration.
-#
-devel/expat-2.1.0-1
-tools/rtems-binutils-2.20.1-1
-tools/rtems-gcc-4.4.7-newlib-1.18.0-1
-tools/rtems-gdb-7.3.1-1
-tools/rtems-kernel-4.10.2
Index: ems/config/4.9/rtems-all.bset
===================================================================
--- rtems/config/4.9/rtems-all.bset	(revision cac72a2aea711f671816d7c41bb1cfe66d54ee37)
+++ 	(revision )
@@ -1,11 +1,0 @@
-#
-# All RTEMS 4.9 Tools Sets
-#
-
-4.9/rtems-autotools
-4.9/rtems-arm
-4.9/rtems-i386
-4.9/rtems-m68k
-4.9/rtems-mips
-4.9/rtems-powerpc
-4.9/rtems-sparc
Index: ems/config/4.9/rtems-arm.bset
===================================================================
--- rtems/config/4.9/rtems-arm.bset	(revision cac72a2aea711f671816d7c41bb1cfe66d54ee37)
+++ 	(revision )
@@ -1,39 +1,0 @@
-#
-# Tools Set for RTEMS ARM 4.9 Stable
-#
-
-%define release 1
-
-%define rtems_arch arm
-
-
-#
-# The RTEMS 4.9 BSP to build and test
-#
-# Do not build: lm3s3749
-# For automated testing, edb7312 should be configured with:
-#    - ON_SKYEYE=1
-# The GDB based simulators could be used as defaults for testing though.
-# Skyeye includes coverage.
-#
-%define rtems_bsps      all
-%define rtems_test_bsps none
-
-#
-# The RTEMS 4.9 base defines.
-#
-%include rtems-4.9-base.bset
-
-#
-# Need to add this option to build.
-#
-%define enable_obsolete 1
-
-#
-# Tools configuration.
-#
-devel/expat-2.1.0-1
-tools/rtems-binutils-2.19.1-1
-tools/rtems-gcc-4.3.2-newlib-1.16.0-1
-tools/rtems-gdb-6.8-1
-tools/rtems-kernel-4.9.6-1
Index: ems/config/4.9/rtems-autotools.bset
===================================================================
--- rtems/config/4.9/rtems-autotools.bset	(revision cac72a2aea711f671816d7c41bb1cfe66d54ee37)
+++ 	(revision )
@@ -1,23 +1,0 @@
-#
-# Tools Set for RTEMS 4.9 Autotools Stable
-#
-
-%define release 1
-
-%define rtems_arch none
-
-#
-# The RTEMS 4.9 base defines.
-#
-%include rtems-4.9-base.bset
-
-#
-# The autotoolspackage.
-#
-package: rtems-%{rtems_version}-autotools-%{_host}-%{release}
-
-#
-# Tools configuration.
-#
-devel/autoconf-2.69-1
-devel/automake-1.12.2-1
Index: ems/config/4.9/rtems-i386.bset
===================================================================
--- rtems/config/4.9/rtems-i386.bset	(revision cac72a2aea711f671816d7c41bb1cfe66d54ee37)
+++ 	(revision )
@@ -1,30 +1,0 @@
-#
-# Tools Set for RTEMS i386 4.9 Stable
-#
-
-%define release 1
-
-%define rtems_arch i386
-
-#
-# The RTEMS 4.9 BSP to build and test
-#
-# For automated testing on Qemu, pc386 should be configured with:
-#    - USE_COM1_AS_CONSOLE=1
-#    - BSP_PRESS_KEY_FOR_RESET=0
-#    - BSP_RESET_BOARD_AT_EXIT=1
-%define rtems_bsps      all
-%define rtems_test_bsps none
-#
-# The RTEMS 4.9 base defines.
-#
-%include rtems-4.9-base.bset
-
-#
-# Tools configuration.
-#
-devel/expat-2.1.0-1
-tools/rtems-binutils-2.19.1-1
-tools/rtems-gcc-4.3.2-newlib-1.16.0-1
-tools/rtems-gdb-6.8-1
-tools/rtems-kernel-4.9.6-1
Index: ems/config/4.9/rtems-m68k.bset
===================================================================
--- rtems/config/4.9/rtems-m68k.bset	(revision cac72a2aea711f671816d7c41bb1cfe66d54ee37)
+++ 	(revision )
@@ -1,34 +1,0 @@
-#
-# Tools Set for RTEMS m68k 4.9 Stable
-#
-
-%define release 1
-
-%define rtems_arch m68k
-
-#
-# The RTEMS 4.9 base defines.
-#
-%include rtems-4.9-base.bset
-
-#
-# The RTEMS 4.9 BSP to build and test
-#
-# uC5282 requires a patched special version of Qemu
-%define rtems_bsps      all
-%define rtems_test_bsps none
-
-
-#
-# Disable the tests because the samples do not build.
-#
-%define rtems_tests disable
-
-#
-# Tools configuration.
-#
-devel/expat-2.1.0-1
-tools/rtems-binutils-2.19.1-1
-tools/rtems-gcc-4.3.2-newlib-1.16.0-1
-tools/rtems-gdb-6.8-1
-tools/rtems-kernel-4.9.6-1
Index: ems/config/4.9/rtems-mips.bset
===================================================================
--- rtems/config/4.9/rtems-mips.bset	(revision cac72a2aea711f671816d7c41bb1cfe66d54ee37)
+++ 	(revision )
@@ -1,27 +1,0 @@
-#
-# Tools Set for RTEMS MIPS 4.9 Stable
-#
-
-%define release 1
-
-%define rtems_arch mips
-
-#
-# The RTEMS 4.9 BSP to build and test
-#
-%define rtems_bsps      all
-%define rtems_test_bsps jmr3904
-
-#
-# The RTEMS 4.9 base defines.
-#
-%include rtems-4.9-base.bset
-
-#
-# Tools configuration.
-#
-devel/expat-2.1.0-1
-tools/rtems-binutils-2.19.1-1
-tools/rtems-gcc-4.3.2-newlib-1.16.0-1
-tools/rtems-gdb-6.8-1
-tools/rtems-kernel-4.9.6-1
Index: ems/config/4.9/rtems-powerpc.bset
===================================================================
--- rtems/config/4.9/rtems-powerpc.bset	(revision cac72a2aea711f671816d7c41bb1cfe66d54ee37)
+++ 	(revision )
@@ -1,27 +1,0 @@
-#
-# Tools Set for RTEMS PowerPC 4.9 Stable
-#
-
-%define release 1
-
-%define rtems_arch powerpc
-
-#
-# The RTEMS 4.9 BSP to build and test
-#
-%define rtems_bsps      all
-%define rtems_test_bsps psim
-
-#
-# The RTEMS 4.9 base defines.
-#
-%include rtems-4.9-base.bset
-
-#
-# Tools configuration.
-#
-devel/expat-2.1.0-1
-tools/rtems-binutils-2.19.1-1
-tools/rtems-gcc-4.3.2-newlib-1.16.0-1
-tools/rtems-gdb-6.8-1
-tools/rtems-kernel-4.9.6-1
Index: ems/config/4.9/rtems-sparc.bset
===================================================================
--- rtems/config/4.9/rtems-sparc.bset	(revision cac72a2aea711f671816d7c41bb1cfe66d54ee37)
+++ 	(revision )
@@ -1,28 +1,0 @@
-#
-# Tools Set for RTEMS SPARC 4.9 Stable
-#
-
-%define release 1
-
-%define rtems_arch sparc
-
-
-#
-# The RTEMS 4.11 BSP to build and test
-#
-%define rtems_bsps      all
-%define rtems_test_bsps sis
-
-#
-# The RTEMS 4.11 base defines.
-#
-%include rtems-4.9-base.bset
-
-#
-# Tools configuration.
-#
-devel/expat-2.1.0-1
-tools/rtems-binutils-2.19.1-1
-tools/rtems-gcc-4.3.2-newlib-1.16.0-1
-tools/rtems-gdb-6.8-1
-tools/rtems-kernel-4.9.6-1
Index: ems/config/rtems-4.10-base.bset
===================================================================
--- rtems/config/rtems-4.10-base.bset	(revision cac72a2aea711f671816d7c41bb1cfe66d54ee37)
+++ 	(revision )
@@ -1,7 +1,0 @@
-#
-# Base defines for RTEMS 4.10
-#
-
-%define rtems_version 4.10
-
-%include rtems-base.bset
Index: ems/config/rtems-4.9-base.bset
===================================================================
--- rtems/config/rtems-4.9-base.bset	(revision cac72a2aea711f671816d7c41bb1cfe66d54ee37)
+++ 	(revision )
@@ -1,7 +1,0 @@
-#
-# Base defines for RTEMS 4.9
-#
-
-%define rtems_version 4.9
-
-%include rtems-base.bset