Index: tools/build/.cvsignore
===================================================================
--- tools/build/.cvsignore	(revision 4619da90eb98451bea69ac5615407472f95af0ff)
+++ tools/build/.cvsignore	(revision 907ef1f68089bcb740cb9a7cdf1d210470030663)
@@ -14,7 +14,5 @@
 install-if-change
 install-sh
-lock-directory
 missing
 mkinstalldirs
 stamp-h.in
-unlock-directory
Index: tools/build/ChangeLog
===================================================================
--- tools/build/ChangeLog	(revision 4619da90eb98451bea69ac5615407472f95af0ff)
+++ tools/build/ChangeLog	(revision 907ef1f68089bcb740cb9a7cdf1d210470030663)
@@ -1,2 +1,7 @@
+2002-05-01	Joel Sherrill <joel@OARcorp.com>
+
+	* lock-directory.in, unlock-directory.in: Removed.
+	* Makefile.am, README, .cvsignore: Updated to reflect above.
+
 2002-04-01	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
 
Index: tools/build/Makefile.am
===================================================================
--- tools/build/Makefile.am	(revision 4619da90eb98451bea69ac5615407472f95af0ff)
+++ tools/build/Makefile.am	(revision 907ef1f68089bcb740cb9a7cdf1d210470030663)
@@ -15,5 +15,5 @@
 binpatch_SOURCES = binpatch.c
 
-bin_SCRIPTS = install-if-change lock-directory unlock-directory
+bin_SCRIPTS = install-if-change
 
 noinst_SCRIPTS = search-id.sh multigen
Index: tools/build/README
===================================================================
--- tools/build/README	(revision 4619da90eb98451bea69ac5615407472f95af0ff)
+++ tools/build/README	(revision 907ef1f68089bcb740cb9a7cdf1d210470030663)
@@ -4,6 +4,4 @@
 
 Misc. support tools for RTEMS workspaces.
-More will be added later as they are converted from Teamware
-to CVS.
 
 install-if-change
@@ -11,14 +9,2 @@
     installs (suffixes used for debug and profile variants).
     Requires bash or ksh.
-
-rcs-clean
-    deletes all files from the current directory that can be
-    re-created from RCS.  Careful to not delete locked files.
-    May be used by 'gmake clobber'
-
-lock-directory
-unlock-directory
-    traverse a directory structure making it unwritable.
-    Useful to keep people from accidentally overwriting
-    "released" trees if they get confused about which
-    module they have loaded.
Index: tools/build/configure.ac
===================================================================
--- tools/build/configure.ac	(revision 4619da90eb98451bea69ac5615407472f95af0ff)
+++ tools/build/configure.ac	(revision 907ef1f68089bcb740cb9a7cdf1d210470030663)
@@ -24,6 +24,4 @@
 AC_CONFIG_FILES([Makefile
 install-if-change
-lock-directory
-unlock-directory
 ])
 AC_OUTPUT
Index: ols/build/lock-directory.in
===================================================================
--- tools/build/lock-directory.in	(revision 4619da90eb98451bea69ac5615407472f95af0ff)
+++ 	(revision )
@@ -1,43 +1,0 @@
-#!@KSH@
-#
-# $Id$
-#
-# Make a directory write protected
-# Used to write protect the install point after a build
-# to prevent inadvertant overwriting.
-#
-
-# is a particular command available on this machine?
-#
-cmd_avail()
-{
-    set -- `type $1 2>&1`
-    if [ "$2" = "not" -a "$3" = "found" ] || [ "$3" = "not" -a "$4" = "found" ]
-    then
-        return 1
-    else
-        return 0
-    fi
-}
-
-lock_directory() {
-    l_dir=$1/.			# get any symlink out of the way using '.'
-    if [ -d $l_dir ]
-    then
-        find $l_dir -type d -perm -0200 -print | $XARGS chmod -w
-    fi
-}
-
-# Use gnu xargs if available; faster, more reliable in general
-XARGS=xargs
-cmd_avail gxargs && XARGS=gxargs
-
-for dir
-do
-    lock_directory $dir
-done
-
-# Local Variables: ***
-# mode:ksh ***
-# End: ***
-
Index: ols/build/unlock-directory.in
===================================================================
--- tools/build/unlock-directory.in	(revision 4619da90eb98451bea69ac5615407472f95af0ff)
+++ 	(revision )
@@ -1,41 +1,0 @@
-#!@KSH@
-#
-# $Id$
-#
-# Unlock a directory processed by lock_directory
-#
-
-# is a particular command available on this machine?
-#
-cmd_avail()
-{
-    set -- `type $1 2>&1`
-    if [ "$2" = "not" -a "$3" = "found" ] || [ "$3" = "not" -a "$4" = "found" ]
-    then
-        return 1
-    else
-        return 0
-    fi
-}
-
-unlock_directory() {
-    ul_dir=$1/.  		# get any symlink out of the way using '.'
-    if [ -d $ul_dir ]
-    then
-        find $ul_dir -type d ! -perm -0222 -print | $XARGS -t chmod +w
-    fi
-}
-
-# Use gnu xargs if available; faster, more reliable in general
-XARGS=xargs
-cmd_avail gxargs && XARGS=gxargs
-
-for dir
-do
-    unlock_directory $dir
-done
-
-# Local Variables: ***
-# mode:ksh ***
-# End: ***
-