Index: c/src/tests/psxtests/psxfile01/psxfile01.scn
===================================================================
--- c/src/tests/psxtests/psxfile01/psxfile01.scn	(revision 6b719b8d127cd21d3233090ae2cc9dc855ce7504)
+++ c/src/tests/psxtests/psxfile01/psxfile01.scn	(revision 912f74ae47605f01382171df1ec98c15bd7191e3)
@@ -29,4 +29,11 @@
 
 rmdir /usr
+rmdir /dev
+rmdir /fred
+mknod /dev/test_console
+mknod /dev/tty/S3
+mknod /etc/passwd
+mkdir /tmp/my_dir
+mkfifo /c/my_dir
 mkdir /etc/passwd/j
 open /tmp/joel - should fail with ENOENT
@@ -34,11 +41,18 @@
 open returned file descriptor 3
 close /tmp/j
+close /tmp/j again
 unlink /tmp/j
+unlink /tmp
+create and close /tmp/tom
+Attempt to recreate /tmp/tom
+create /tmp/john
+tcdrain /tmp/john
+mknod /tmp/joel
 (0)the first write!!!
 
 (10)the first write!!!
 
-stat( /tmp/joel ) returned     st_dev     (0x1a7f8:0x3e86f0)
-    st_ino     d
+stat( /tmp/joel ) returned     st_dev     (0x0:0x0)
+    st_ino     10
     mode  = 00100700
     nlink = 1
@@ -48,4 +62,7 @@
     mtime = Sat Dec 31 09:00:00 1988
     ctime = Sat Dec 31 09:00:00 1988
+unlink /tmp/joel
+unlink /tmp/joel
+mknod /tmp/joel
 (514)the first write!!!
 
@@ -65,6 +82,6 @@
 
 (139743)
-stat( /tmp/joel ) returned     st_dev     (0x1a7f8:0x3e86f0)
-    st_ino     e
+stat( /tmp/joel ) returned     st_dev     (0x0:0x0)
+    st_ino     11
     mode  = 00100700
     nlink = 1
@@ -93,5 +110,5 @@
 (5) 26 characters written to the file
     st_dev     (0x0:0x0)
-    st_ino     f
+    st_ino     12
     mode  = 00100660
     nlink = 1
@@ -107,5 +124,5 @@
 This is call 5 to fprintf
     st_dev     (0x0:0x0)
-    st_ino     f
+    st_ino     12
     mode  = 00100660
     nlink = 1
@@ -125,10 +142,13 @@
         passwd (file 0 0x0 0x0 0x0)
     tmp/
-        joel (file 279487 0x3d5ac0 0x3d5570 0x3d5020)
-        j (file 130 0x37f530 0x0 0x0)
+        my_dir/
+        tom (file 0 0x0 0x0 0x0)
+        john (file 0 0x0 0x0 0x0)
+        joel (file 279487 0x7d58d8 0x7d5388 0x7cfe38)
+        j (file 130 0x77a338 0x0 0x0)
 ***************       End of Dump        ***************
 truncate /tmp/j to length of 40
     st_dev     (0x0:0x0)
-    st_ino     f
+    st_ino     12
     mode  = 00100660
     nlink = 1
@@ -148,5 +168,8 @@
         passwd (file 0 0x0 0x0 0x0)
     tmp/
-        j (file 40 0x37f530 0x0 0x0)
+        my_dir/
+        tom (file 0 0x0 0x0 0x0)
+        john (file 0 0x0 0x0 0x0)
+        j (file 40 0x77a338 0x0 0x0)
 ***************       End of Dump        ***************
 truncate /tmp/j to length of 0
@@ -164,5 +187,9 @@
         passwd (file 0 0x0 0x0 0x0)
     tmp/
-        j (file 0 0x37f530 0x0 0x0)
+        my_dir/
+        tom (file 0 0x0 0x0 0x0)
+        john (file 0 0x0 0x0 0x0)
+        j (file 0 0x77a338 0x0 0x0)
 ***************       End of Dump        ***************
 *** END OF FILE TEST 1 ***
+
Index: testsuites/psxtests/psxfile01/psxfile01.scn
===================================================================
--- testsuites/psxtests/psxfile01/psxfile01.scn	(revision 6b719b8d127cd21d3233090ae2cc9dc855ce7504)
+++ testsuites/psxtests/psxfile01/psxfile01.scn	(revision 912f74ae47605f01382171df1ec98c15bd7191e3)
@@ -29,4 +29,11 @@
 
 rmdir /usr
+rmdir /dev
+rmdir /fred
+mknod /dev/test_console
+mknod /dev/tty/S3
+mknod /etc/passwd
+mkdir /tmp/my_dir
+mkfifo /c/my_dir
 mkdir /etc/passwd/j
 open /tmp/joel - should fail with ENOENT
@@ -34,11 +41,18 @@
 open returned file descriptor 3
 close /tmp/j
+close /tmp/j again
 unlink /tmp/j
+unlink /tmp
+create and close /tmp/tom
+Attempt to recreate /tmp/tom
+create /tmp/john
+tcdrain /tmp/john
+mknod /tmp/joel
 (0)the first write!!!
 
 (10)the first write!!!
 
-stat( /tmp/joel ) returned     st_dev     (0x1a7f8:0x3e86f0)
-    st_ino     d
+stat( /tmp/joel ) returned     st_dev     (0x0:0x0)
+    st_ino     10
     mode  = 00100700
     nlink = 1
@@ -48,4 +62,7 @@
     mtime = Sat Dec 31 09:00:00 1988
     ctime = Sat Dec 31 09:00:00 1988
+unlink /tmp/joel
+unlink /tmp/joel
+mknod /tmp/joel
 (514)the first write!!!
 
@@ -65,6 +82,6 @@
 
 (139743)
-stat( /tmp/joel ) returned     st_dev     (0x1a7f8:0x3e86f0)
-    st_ino     e
+stat( /tmp/joel ) returned     st_dev     (0x0:0x0)
+    st_ino     11
     mode  = 00100700
     nlink = 1
@@ -93,5 +110,5 @@
 (5) 26 characters written to the file
     st_dev     (0x0:0x0)
-    st_ino     f
+    st_ino     12
     mode  = 00100660
     nlink = 1
@@ -107,5 +124,5 @@
 This is call 5 to fprintf
     st_dev     (0x0:0x0)
-    st_ino     f
+    st_ino     12
     mode  = 00100660
     nlink = 1
@@ -125,10 +142,13 @@
         passwd (file 0 0x0 0x0 0x0)
     tmp/
-        joel (file 279487 0x3d5ac0 0x3d5570 0x3d5020)
-        j (file 130 0x37f530 0x0 0x0)
+        my_dir/
+        tom (file 0 0x0 0x0 0x0)
+        john (file 0 0x0 0x0 0x0)
+        joel (file 279487 0x7d58d8 0x7d5388 0x7cfe38)
+        j (file 130 0x77a338 0x0 0x0)
 ***************       End of Dump        ***************
 truncate /tmp/j to length of 40
     st_dev     (0x0:0x0)
-    st_ino     f
+    st_ino     12
     mode  = 00100660
     nlink = 1
@@ -148,5 +168,8 @@
         passwd (file 0 0x0 0x0 0x0)
     tmp/
-        j (file 40 0x37f530 0x0 0x0)
+        my_dir/
+        tom (file 0 0x0 0x0 0x0)
+        john (file 0 0x0 0x0 0x0)
+        j (file 40 0x77a338 0x0 0x0)
 ***************       End of Dump        ***************
 truncate /tmp/j to length of 0
@@ -164,5 +187,9 @@
         passwd (file 0 0x0 0x0 0x0)
     tmp/
-        j (file 0 0x37f530 0x0 0x0)
+        my_dir/
+        tom (file 0 0x0 0x0 0x0)
+        john (file 0 0x0 0x0 0x0)
+        j (file 0 0x77a338 0x0 0x0)
 ***************       End of Dump        ***************
 *** END OF FILE TEST 1 ***
+