Index: org.rtems.cdt.toolchain2/.project
===================================================================
--- org.rtems.cdt.toolchain2/.project	(revision 914bad0b9bae24e2bf97689dfc52579616070992)
+++ org.rtems.cdt.toolchain2/.project	(revision 914bad0b9bae24e2bf97689dfc52579616070992)
@@ -0,0 +1,28 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<projectDescription>
+	<name>org.rtems.cdt.toolchain2</name>
+	<comment></comment>
+	<projects>
+	</projects>
+	<buildSpec>
+		<buildCommand>
+			<name>org.eclipse.jdt.core.javabuilder</name>
+			<arguments>
+			</arguments>
+		</buildCommand>
+		<buildCommand>
+			<name>org.eclipse.pde.ManifestBuilder</name>
+			<arguments>
+			</arguments>
+		</buildCommand>
+		<buildCommand>
+			<name>org.eclipse.pde.SchemaBuilder</name>
+			<arguments>
+			</arguments>
+		</buildCommand>
+	</buildSpec>
+	<natures>
+		<nature>org.eclipse.pde.PluginNature</nature>
+		<nature>org.eclipse.jdt.core.javanature</nature>
+	</natures>
+</projectDescription>
Index: org.rtems.cdt.toolchain2/LICENSE
===================================================================
--- org.rtems.cdt.toolchain2/LICENSE	(revision 914bad0b9bae24e2bf97689dfc52579616070992)
+++ org.rtems.cdt.toolchain2/LICENSE	(revision 914bad0b9bae24e2bf97689dfc52579616070992)
@@ -0,0 +1,20 @@
+                      LICENSE INFORMATION
+
+RTEMS is free software; you can redistribute it and/or modify it under
+terms of the GNU General Public License as published by the
+Free Software Foundation; either version 2, or (at your option) any
+later version.  RTEMS is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+General Public License for more details. You should have received
+a copy of the GNU General Public License along with RTEMS; see
+file COPYING. If not, write to the Free Software Foundation, 675
+Mass Ave, Cambridge, MA 02139, USA.
+
+As a special exception, including RTEMS header files in a file,
+instantiating RTEMS generics or templates, or linking other files
+with RTEMS objects to produce an executable application, does not
+by itself cause the resulting executable application to be covered
+by the GNU General Public License. This exception does not
+however invalidate any other reasons why the executable file might be
+covered by the GNU Public License.
Index: org.rtems.cdt.toolchain2/META-INF/MANIFEST.MF
===================================================================
--- org.rtems.cdt.toolchain2/META-INF/MANIFEST.MF	(revision 914bad0b9bae24e2bf97689dfc52579616070992)
+++ org.rtems.cdt.toolchain2/META-INF/MANIFEST.MF	(revision 914bad0b9bae24e2bf97689dfc52579616070992)
@@ -0,0 +1,8 @@
+Manifest-Version: 1.0
+Bundle-ManifestVersion: 2
+Bundle-Name: RTEMS CDT Plug-in
+Bundle-SymbolicName: org.rtems.cdt.toolchain2;singleton:=true
+Bundle-Version: 1.0.0
+Bundle-RequiredExecutionEnvironment: JavaSE-1.6
+Require-Bundle: org.eclipse.cdt.managedbuilder.core
+Bundle-Vendor: Embedded Brains GmbH
Index: org.rtems.cdt.toolchain2/build.properties
===================================================================
--- org.rtems.cdt.toolchain2/build.properties	(revision 914bad0b9bae24e2bf97689dfc52579616070992)
+++ org.rtems.cdt.toolchain2/build.properties	(revision 914bad0b9bae24e2bf97689dfc52579616070992)
@@ -0,0 +1,5 @@
+source.. = src/
+output.. = bin/
+bin.includes = META-INF/,\
+               .,\
+               plugin.xml
Index: org.rtems.cdt.toolchain2/plugin.xml
===================================================================
--- org.rtems.cdt.toolchain2/plugin.xml	(revision 914bad0b9bae24e2bf97689dfc52579616070992)
+++ org.rtems.cdt.toolchain2/plugin.xml	(revision 914bad0b9bae24e2bf97689dfc52579616070992)
@@ -0,0 +1,240 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<?eclipse version="3.2"?>
+<!--
+	Copyright (c) 2008
+	Embedded Brains GmbH
+	Obere Lagerstr. 30
+	D-82178 Puchheim
+	Germany
+	rtems@embedded-brains.de
+	
+	The license and distribution terms for this file may be found in the file
+	LICENSE in this distribution or at http://www.rtems.com/license/LICENSE.
+-->
+<plugin>
+	<!-- Scanner Configuration Discovery Profiles -->
+	<extension
+			id="RtemsSCDProfile"
+			name="RTEMS Scanner Configuration Discovery Profile (UNIX)"
+			point="org.eclipse.cdt.make.core.ScannerConfigurationDiscoveryProfile">
+		<scannerInfoCollector
+				class="org.eclipse.cdt.make.internal.core.scannerconfig2.PerProjectSICollector"
+				scope="project"/>
+		<buildOutputProvider>
+			<open/>
+			<scannerInfoConsoleParser class="org.eclipse.cdt.managedbuilder.internal.scannerconfig.ManagedGCCScannerInfoConsoleParser"/>
+		</buildOutputProvider>
+		<scannerInfoProvider providerId="specsFile">
+			<run
+					arguments="-E -P -v -dD ${plugin_state_location}/${specs_file}"
+					command="powerpc-rtems4.10-gcc"
+					class="org.eclipse.cdt.make.internal.core.scannerconfig2.GCCSpecsRunSIProvider"/>
+			<scannerInfoConsoleParser class="org.eclipse.cdt.make.internal.core.scannerconfig.gnu.GCCSpecsConsoleParser"/>
+		</scannerInfoProvider>
+	</extension>
+	<extension
+			id="RtemsSCDProfileC"
+			name="RTEMS Scanner Configuration Discovery Profile (UNIX)"
+			point="org.eclipse.cdt.make.core.ScannerConfigurationDiscoveryProfile">
+		<scannerInfoCollector
+				class="org.eclipse.cdt.make.internal.core.scannerconfig2.PerProjectSICollector"
+				scope="project"/>
+		<buildOutputProvider>
+			<open/>
+			<scannerInfoConsoleParser class="org.eclipse.cdt.managedbuilder.internal.scannerconfig.ManagedGCCScannerInfoConsoleParser"/>
+		</buildOutputProvider>
+		<scannerInfoProvider providerId="specsFile">
+			<run
+					arguments="-E -P -v -dD ${plugin_state_location}/specs.c"
+					command="powerpc-rtems4.10-gcc"
+					class="org.eclipse.cdt.make.internal.core.scannerconfig2.GCCSpecsRunSIProvider"/>
+			<scannerInfoConsoleParser class="org.eclipse.cdt.make.internal.core.scannerconfig.gnu.GCCSpecsConsoleParser"/>
+		</scannerInfoProvider>
+	</extension>
+	<extension
+			id="RtemsSCDProfileCPP"
+			name="RTEMS Scanner Configuration Discovery Profile (UNIX)"
+			point="org.eclipse.cdt.make.core.ScannerConfigurationDiscoveryProfile">
+		<scannerInfoCollector
+				class="org.eclipse.cdt.make.internal.core.scannerconfig2.PerProjectSICollector"
+				scope="project"/>
+		<buildOutputProvider>
+			<open/>
+			<scannerInfoConsoleParser class="org.eclipse.cdt.managedbuilder.internal.scannerconfig.ManagedGCCScannerInfoConsoleParser"/>
+		</buildOutputProvider>
+		<scannerInfoProvider providerId="specsFile">
+			<run
+					arguments="-E -P -v -dD ${plugin_state_location}/specs.cpp"
+					command="powerpc-rtems4.10-g++"
+					class="org.eclipse.cdt.make.internal.core.scannerconfig2.GCCSpecsRunSIProvider"/>
+			<scannerInfoConsoleParser class="org.eclipse.cdt.make.internal.core.scannerconfig.gnu.GCCSpecsConsoleParser"/>
+		</scannerInfoProvider>
+	</extension>
+	<extension
+			id="RtemsSCDProfileWin"
+			name="RTEMS Scanner Configuration Discovery Profile (Windows)"
+			point="org.eclipse.cdt.make.core.ScannerConfigurationDiscoveryProfile">
+		<scannerInfoCollector
+				class="org.eclipse.cdt.managedbuilder.internal.scannerconfig.DefaultGnuWinScannerInfoCollector"
+				scope="project"/>
+		<buildOutputProvider>
+			<open/>
+			<scannerInfoConsoleParser class="org.eclipse.cdt.managedbuilder.internal.scannerconfig.ManagedGCCScannerInfoConsoleParser"/>
+		</buildOutputProvider>
+		<scannerInfoProvider providerId="specsFile">
+			<run
+					arguments="-E -P -v -dD ${plugin_state_location}/${specs_file}"
+					command="powerpc-rtems4.10-gcc"
+					class="org.eclipse.cdt.make.internal.core.scannerconfig2.GCCSpecsRunSIProvider"/>
+			<scannerInfoConsoleParser class="org.eclipse.cdt.make.internal.core.scannerconfig.gnu.GCCSpecsConsoleParser"/>
+		</scannerInfoProvider>
+	</extension>
+	<extension
+			id="RtemsSCDProfileWinC"
+			name="RTEMS Scanner Configuration Discovery Profile (Windows)"
+			point="org.eclipse.cdt.make.core.ScannerConfigurationDiscoveryProfile">
+		<scannerInfoCollector
+				class="org.eclipse.cdt.managedbuilder.internal.scannerconfig.DefaultGnuWinScannerInfoCollector"
+				scope="project"/>
+		<buildOutputProvider>
+			<open/>
+			<scannerInfoConsoleParser class="org.eclipse.cdt.managedbuilder.internal.scannerconfig.ManagedGCCScannerInfoConsoleParser"/>
+		</buildOutputProvider>
+		<scannerInfoProvider providerId="specsFile">
+			<run
+					arguments="-E -P -v -dD ${plugin_state_location}/specs.c"
+					command="powerpc-rtems4.10-gcc"
+					class="org.eclipse.cdt.make.internal.core.scannerconfig2.GCCSpecsRunSIProvider"/>
+			<scannerInfoConsoleParser class="org.eclipse.cdt.make.internal.core.scannerconfig.gnu.GCCSpecsConsoleParser"/>
+		</scannerInfoProvider>
+	</extension>
+	<extension
+			id="RtemsSCDProfileWinCPP"
+			name="RTEMS Scanner Configuration Discovery Profile (Windows)"
+			point="org.eclipse.cdt.make.core.ScannerConfigurationDiscoveryProfile">
+		<scannerInfoCollector
+				class="org.eclipse.cdt.managedbuilder.internal.scannerconfig.DefaultGnuWinScannerInfoCollector"
+				scope="project"/>
+		<buildOutputProvider>
+			<open/>
+			<scannerInfoConsoleParser class="org.eclipse.cdt.managedbuilder.internal.scannerconfig.ManagedGCCScannerInfoConsoleParser"/>
+		</buildOutputProvider>
+		<scannerInfoProvider providerId="specsFile">
+			<run
+					arguments="-E -P -v -dD ${plugin_state_location}/specs.cpp"
+					command="powerpc-rtems4.10-g++"
+					class="org.eclipse.cdt.make.internal.core.scannerconfig2.GCCSpecsRunSIProvider"/>
+			<scannerInfoConsoleParser class="org.eclipse.cdt.make.internal.core.scannerconfig.gnu.GCCSpecsConsoleParser"/>
+		</scannerInfoProvider>
+	</extension>
+
+	<!-- Build Definitions -->
+	<extension
+			id="org.rtems.cdt.build"
+			point="org.eclipse.cdt.managedbuilder.core.buildDefinitions">
+		<configuration
+				id="org.rtems.cdt.config.base"
+				name="RTEMS Configuration"
+				cleanCommand="rm -rf"
+				artifactExtension="exe">
+			<enablement type="CONTAINER_ATTRIBUTE"
+					attribute="artifactExtension"
+					value="a"
+					extensionAdjustment="false">
+				<checkBuildProperty
+						property="org.eclipse.cdt.build.core.buildArtefactType"
+						value="org.eclipse.cdt.build.core.buildArtefactType.staticLib"/>
+			</enablement>
+		</configuration>
+		<toolChain
+				id="org.rtems.cdt.toolchain"
+				name="RTEMS Toolchain (UNIX)"
+				archList="all"
+				osList="linux,solaris,hpux,aix,qnx"
+				targetTool="org.rtems.cdt.c.linker;org.rtems.cdt.cpp.linker;org.rtems.cdt.archiver"
+				scannerConfigDiscoveryProfileId="org.rtems.cdt.toolchain2.RtemsSCDProfile">
+			<targetPlatform
+				id="org.rtems.cdt.target"
+				name="RTEMS Target"
+				binaryParser="org.eclipse.cdt.core.ELF"
+				osList="all"
+				archList="all">
+			</targetPlatform>
+			<builder
+					id="org.rtems.cdt.builder"
+					superClass="cdt.managedbuild.target.gnu.builder"/>
+			<tool
+					id="org.rtems.cdt.c.compiler"
+					superClass="cdt.managedbuild.tool.gnu.c.compiler"
+					command="powerpc-rtems4.10-gcc">
+				<inputType
+						id="org.rtems.cdt.c.compiler.input"
+						superClass="cdt.managedbuild.tool.gnu.c.compiler.input"
+						scannerConfigDiscoveryProfileId="org.rtems.cdt.toolchain2.RtemsSCDProfileC"/>
+			</tool>
+			<tool
+					id="org.rtems.cdt.cpp.compiler"
+					superClass="cdt.managedbuild.tool.gnu.cpp.compiler"
+					command="powerpc-rtems4.10-g++">
+				<inputType
+						id="org.rtems.cdt.cpp.compiler.input"
+						superClass="cdt.managedbuild.tool.gnu.cpp.compiler.input"
+						scannerConfigDiscoveryProfileId="org.rtems.cdt.toolchain2.RtemsSCDProfileCPP"/>
+			</tool>
+			<tool
+					id="org.rtems.cdt.assembler"
+					superClass="cdt.managedbuild.tool.gnu.assembler"
+					command="powerpc-rtems4.10-as">
+			</tool>
+			<tool
+					id="org.rtems.cdt.c.linker"
+					superClass="cdt.managedbuild.tool.gnu.c.linker"
+					command="powerpc-rtems4.10-gcc">
+				<enablement type="ALL">
+					<not>
+						<checkBuildProperty
+							property="org.eclipse.cdt.build.core.buildArtefactType"
+							value="org.eclipse.cdt.build.core.buildArtefactType.staticLib"/>
+					</not>
+				</enablement>
+			</tool>
+			<tool
+					id="org.rtems.cdt.cpp.linker"
+					superClass="cdt.managedbuild.tool.gnu.cpp.linker"
+					command="powerpc-rtems4.10-g++">
+				<enablement type="ALL">
+					<not>
+					<checkBuildProperty
+							property="org.eclipse.cdt.build.core.buildArtefactType"
+							value="org.eclipse.cdt.build.core.buildArtefactType.staticLib"/>
+					</not>
+				</enablement>
+			</tool>
+			<tool
+					id="org.rtems.cdt.archiver"
+					superClass="cdt.managedbuild.tool.gnu.archiver"
+					command="powerpc-rtems4.10-ar">
+				<enablement type="ALL">
+					<checkBuildProperty
+							property="org.eclipse.cdt.build.core.buildArtefactType"
+							value="org.eclipse.cdt.build.core.buildArtefactType.staticLib"/>
+				</enablement>
+			</tool>
+		</toolChain>
+		<projectType
+				buildArtefactType="org.eclipse.cdt.build.core.buildArtefactType.exe"
+				id="org.rtems.cdt.project.exe"
+				name="RTEMS Executable">
+			<configuration
+					id="org.rtems.cdt.config.exe"
+					name="RTEMS Executable Configuration"
+					parent="org.rtems.cdt.config.base"
+					buildProperties="org.eclipse.cdt.build.core.buildType=org.eclipse.cdt.build.core.buildType.release">
+				<toolChain
+						id="org.rtems.cdt.toolchain.exe"
+						superClass="org.rtems.cdt.toolchain">
+				</toolChain>
+			</configuration>
+		</projectType>
+	</extension>
+</plugin>